using System;
using System.Collections.Generic;
using System.Linq;
using Microsoft.VisualStudio.TestTools.UnitTesting;

namespace DeckOfCards.UnitTests
{
    [TestClass]
    public class DeckFixture
    {
        public DeckFixture()
        {
        }

        [TestMethod]
        public void AnEmptyDeckHasZeroCards()
        {
            var deck = new Deck();

            Assert.AreEqual<int>(0,
                deck.CardCount,
                "Card count should be 0.");
        }

        [TestMethod]
        public void AddingUniqueCardIncrementsTheCardCount()
        {
            var deck = new Deck();

            deck.Add(new Card(Suit.Diamond, Rank.Two));

            Assert.AreEqual<int>(1,
                deck.CardCount,
                "Card count was wrong.");
        }

        [TestMethod]
        [ExpectedException(typeof(InvalidOperationException))]
        public void AddingDuplicateCardThrowsException()
        {
            var deck = new Deck();

            deck.Add(new Card(Suit.Diamond, Rank.Two));

            // add a duplicate card
            deck.Add(new Card(Suit.Diamond, Rank.Two));
        }

        [TestMethod]
        public void InitializeCreates52Cards()
        {
            var deck = new Deck();

            deck.Initialize();

            Assert.AreEqual<int>(52,
                deck.CardCount,
                "Card count was wrong.");
        }
    }
}
